#include "main.h"

int main(int argc, char** argv){

	//Variables temporales
	char *file_name;
	file_name=new char[30];
	char *tempoString;
	tempoString=new char[32];
	char file[3][32];
	int i;

	//Empieza el programa
	printf("CARACTER CONVERSOR V.1.0 BY ANKH\n\n");

	//Le pongo el directorio de trabajo
	printf("WORKING DIRECTORY PATH: ");
	scanf("%s",file_name);
	chdir(file_name);

	//Pido el nombre q tendra el personaje
	printf("SAVE AS: ");
	scanf("%s",file_name);

	printf("INSERT RATIO: ");
	scanf("%f",&RATIO);

	READ=fopen("frames.txt","r");
	if (!READ)  {
		printf("Couldn't find frames file\n");
		return 1;
	}

	while (!feof(READ) && framesPos<50){
		fscanf(READ,"%d %d",&framesPoint[framesPos],&framesPoint[framesPos+1]);
		framesPos+=2;
	}

	fclose (READ);
	if (framesPos!=50){
		printf("ERROR LOADING FRAMES\n");
		return 1;
	}

	framesPos=0;

	//Le aado la coletilla .car y intento crear el fichero
	sprintf(tempoString,"%s.car",file_name);
	CAR=fopen(tempoString,"w");
	if (!CAR) {
		printf("Couldn't create caracter file\n");
		return 1;
	}

	//Le aado la coletilla a los otros 3 archivos y guardo su nombre en un array
	sprintf(file[0],"l_%s.mdh",file_name);
	sprintf(file[1],"b_%s.mdh",file_name);
	sprintf(file[2],"h_%s.mdh",file_name);

	//Escribo los modelos que forman el personaje en el archivo .car
	fprintf(CAR,"LEGS %s\n",file[0]);
	fprintf(CAR,"BODY %s\n",file[1]);
	fprintf(CAR,"HEAD %s\n\n",file[2]);
	

	printf("INSERT DEFAULT SPEED IN TICKS: ");
	scanf("%d",&speed);

	printf("INSERT BODY VARIATION: ");
	scanf("%f",&bodyDesfas);

	printf("INSERT HEAD VARIATION: ");
	scanf("%f",&headDesfas);

	//Cojo el numero de frames y la velocidad y la grabo en el fichero de las piernas
	printf("INSERT NUMBER OF LEGS FRAMES: ");
	scanf("%d",&frames[_LEGS]);

	printf("INSERT NUMBER OF BODY FRAMES: ");
	scanf("%d",&frames[_BODY]);

	printf("INSERT NUMBER OF HEAD FRAMES: ");
	scanf("%d",&frames[_HEAD]);


	weaponPos=new float[frames[_BODY]*3];
	weaponDestiny=new float[frames[_BODY]*3];

	
	//Empezamos a crear las piernas
	printf("CREATING LEGS...\n");

	//Intento crear el fichero para las piernas
	LEGS=fopen(file[0],"w");
	if (!LEGS) {
		printf("Couldn't create legs model file\n");
		return 1;
	}

	//Escribo en fichero del personaje el numero de puntos de union q existen
	fprintf(CAR,"LEGS_UNION_POINTS %d\n",frames[_LEGS]);

	
	//Empiezo a crear las animaciones
	printf("     NOT MOVING\n ");
	if (!inizializate(_LEGS,LEGS,framesPoint[framesPos])){
		printf("ERROR INIZIALITATING LEGS\n");
		return 0;
	}

	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WALKING FORWARD\n ");
	
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;
	
	printf("     WALKING BACKWARD\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;
	
	printf("     RUNNING FORWARD\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     RUNNING BACKWARD\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     JUMPING\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],false)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     CROUCH\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],false)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     STRAFE LEFT\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     STRAFE RIGHT\n ");
	if(!addAnimation(_LEGS,LEGS,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;


	fclose(LEGS);

	printf("\nCREATING BODY...\n");

	for (i=0;i<frames[_BODY]*3;i++) {
		weaponPos[i]=0;
		weaponDestiny[i]=0;
	}

	fprintf(CAR,"BODY_UNION_POINTS %d\n",frames[_BODY]);

	BODY=fopen(file[1],"w");

	if (!BODY) {
		printf("Couldn't create body model file\n");
		return 1;
	}


	printf("     WAITING (WEAPON FACE TO FACE): ");
	

	if (!inizializate(_BODY,BODY,framesPoint[framesPos])){
		printf("ERROR INIZIALITATING BODY\n");
		return 0;
	}

	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WAITING (WEAPON 1 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WAITING (WEAPON 2 HANDS)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WALKING (FACE TO FACE)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WALKING (WEAPON 1 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     WALKING (WEAPON 2 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     SHOOTING (FACE TO FACE)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     SHOOTING (WEAPON 1 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     SHOOTING (WEAPON 2 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     CATCHING (FACE TO FACE)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     CATCHING (WEAPON 1 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     CATCHING (WEAPON 2 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     DROPING (FACE TO FACE)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     DROPING (WEAPON 1 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	printf("     DROPING (WEAPON 2 HAND)\n ");
	if(!addAnimation(_BODY,BODY,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;

	fprintf(CAR,"WEAPON_POS\n");
	for(i=0; i<numWeaponDest;i+=3){
		fprintf(CAR,"%f %f %f\n",weaponPos[i],weaponPos[i+1],weaponPos[i+2]);
	}

	fprintf(CAR,"WEAPON_ANGLE\n");
	for(i=0; i<numWeaponDest;i+=3){
		float yawV,yawH;
		float vec[3]={weaponDestiny[i]-weaponPos[i],weaponDestiny[i+1]-weaponPos[i+1],weaponDestiny[i+2]-weaponPos[i+2]};

		yawH=(float)atan((double)(vec[1]/vec[0]));
		yawV=(float)atan((double)(vec[2]/vec[1]));
		yawH=toDegrees(yawH);
		yawV=toDegrees(yawV);
		fprintf(CAR,"%f %f\n",yawH,yawV);
	}

	fclose(BODY);

	printf("\nCREATING HEAD...\n");

	
	HEAD=fopen(file[2],"w");
	if (!HEAD) {
		printf("Couldn't create head model file\n");
		return 1;
	}

	printf("     HEAD_NORMAL\n ");

	if (!inizializate(_HEAD,HEAD,framesPoint[framesPos])){
		printf("ERROR INIZIALITATING HEAD\n");
		return 0;
	}

	if(!addAnimation(_HEAD,HEAD,framesPoint[framesPos],framesPoint[framesPos+1],true)) {
		printf("ERROR CREATING CHARACTER\n");
		return 0;
	}
	framesPos+=2;
	
	fclose (HEAD);
	fclose (CAR);
	//Solucion a un error de memoria q da al hacer el return

	printf("\nCHARACTER CREATED\n");
	exit (0);
	return 0;
}

bool inizializate(int tipo, FILE *archivo, int begin){

	//Variables temporales
	char *tempo,*textura;
	tempo=new char[30];
	textura=new char[10];
	FILE *origen;
	int num_material=0,j=0,k=0;
	int faces=0,vertex=0;
	float tempoFloat=0;
	int tempoInt=0;


	//Abro el fichero q corresponda
	switch(tipo){
	case _LEGS:
		if (begin >=0 && begin <10) sprintf(tempo,"legs00%d.ase",begin);
		else if (begin >=10 && begin <100) sprintf(tempo,"legs0%d.ase",begin);
		else if (begin >=100 && begin <1000) sprintf(tempo,"legs%d.ase",begin);
		else return false;
		break;
	case _BODY:
		if (begin >=0 && begin <10) sprintf(tempo,"body00%d.ase",begin);
		else if (begin >=10 && begin <100) sprintf(tempo,"body0%d.ase",begin);
		else if (begin >=100 && begin <1000) sprintf(tempo,"body%d.ase",begin);
		else return false;
		break;
	case _HEAD:
		if (begin >=0 && begin <10) sprintf(tempo,"head00%d.ase",begin);
		else if (begin >=10 && begin <100) sprintf(tempo,"head0%d.ase",begin);
		else if (begin >=100 && begin <1000) sprintf(tempo,"head%d.ase",begin);
		else return false;
		break;
	}

	origen=fopen (tempo,"r");
	if (!origen) return false;


	//Miro que material utiliza el modelo
	while (!feof(origen)){
		fscanf(origen,"%s",tempo);
		if (!strcmp(tempo,"*MATERIAL_REF")) fscanf(origen,"%d",&num_material);
	}

	rewind (origen);
			
	//Busco el nombre de la textura del modelo y solo cojo el nombre del archivo
	//(sin la ruta)
	while (!feof(origen) && num_material>=0){
		fscanf(origen,"%s",tempo);
		if (!strcmp(tempo,"*MATERIAL")){
			if (num_material==0){
				do{
					fscanf(origen,"%s",tempo);
				}while (strcmp(tempo,"*BITMAP") && !feof(origen));
				getFileName(origen,textura);
				
			}
			num_material--;
		}
	}

	rewind (origen);
	
	//Empiezo a escribir el fichero
	fprintf(archivo,"#MODEL CREATED BY CAR2MDH CONVERSOR - ANKH 2002\n");
	fprintf(archivo,"#\n");
	fprintf(archivo,"&NUM_FRAMES %d\n",frames[tipo]);
	switch(tipo){
	case _HEAD:
		fprintf(archivo,"&NUM_ANIMATIONS 1\n");
		break;
	case _BODY:
		fprintf(archivo,"&NUM_ANIMATIONS 15\n");
		break;
	case _LEGS:
		fprintf(archivo,"&NUM_ANIMATIONS 9\n");
		break;
	}
	fprintf(archivo,"&SPEED %d\n", speed);
	fprintf(archivo,"&TEXTURE %s\n",textura);

	while (!feof(origen)){
		fscanf(origen,"%s",tempo);

		//Busco la parte del ase correspondiente al modelo en si
		if (!strcmp(tempo,"*NODE_NAME")){
			fscanf(origen,"%s",tempo);
			if (!strcmp(tempo,"\"BODY\"") ||
				  !strcmp(tempo,"\"LEGS\"") ||
				  !strcmp(tempo,"\"HEAD\"")){

				//Busco el numero de vertices q tiene
				do{
					fscanf(origen,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMVERTEX") && !feof(origen));
				fscanf(origen,"%d",&vertex);
				fprintf(archivo,"&VERTEX %d\n",vertex);

				//Busco el numero de caras q tiene
				do{
					fscanf(origen,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMFACES") && !feof(origen));
				fscanf(origen,"%d",&faces);
				fprintf(archivo,"&FACES %d\n",faces);
				//Escribo todas las caras en el fichero
				for (j=0; j<faces;j++){
					do{
						fscanf(origen,"%s",tempo);
					}while(strcmp(tempo,"A:"));
					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d ", tempoInt);

					do{
						fscanf(origen,"%s",tempo);
					}while(strcmp(tempo,"B:"));
					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d ", tempoInt);

					do{
						fscanf(origen,"%s",tempo);
					}while(strcmp(tempo,"C:"));
					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d\n", tempoInt);
				}

				//Busco el numero de vertices de textura q tiene
				do{
					fscanf(origen,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMTVERTEX") && !feof(origen));
				fscanf(origen,"%d",&vertex);
				fprintf(archivo,"\n&MAP_PARTS %d\n", vertex);

				//Escribo todos los vertices de textura en el fichero
				for (j=0; j<vertex;j++){
					do{
						fscanf(origen,"%s",tempo);
					}while(strcmp(tempo,"*MESH_TVERT"));
					fscanf (origen,"%d",&tempoInt);
					fscanf (origen,"%f",&tempoFloat);
					fprintf(archivo,"%f ",tempoFloat);

					fscanf (origen,"%f",&tempoFloat);

					//Se ha de restar la y a 1 para q la lea bien opengl
					fprintf(archivo,"%f\n",1.0f-tempoFloat);
					
				}

				//Escribo el numero de caras de textura q tiene
				do{
					fscanf(origen,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMTVFACES") && !feof(origen));
				fscanf(origen,"%d",&faces);
				fprintf(archivo,"\n&MAP_FACES %d\n", faces);

				//Escribo todas las caras de textura en el fichero
				for (j=0; j<faces;j++){
					do{
						fscanf(origen,"%s",tempo);
					}while(strcmp(tempo,"*MESH_TFACE"));
					fscanf (origen,"%d",&tempoInt);
					
					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d ",tempoInt);
					
					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d ",tempoInt);										

					fscanf (origen,"%d",&tempoInt);
					fprintf(archivo,"%d\n",tempoInt);	
				}

			}
		}
	}
	

	//Cierro el fichero ase
	fclose (origen);
	return true;
}

bool addAnimation(int tipo, FILE *archivo, int begin, int end, bool dinamico){

	//Variables temporales
	FILE *origen;
	char *tempo;
	char *nombreArchivo;
	char *parte;
	tempo=new char[30];
	nombreArchivo=new char[30];
	parte=new char[6];
	int vertex;
	int cont;
	float x,y,z;
	float x_low,y_low,z_low;
	bool ok=false;
	bool done[4]={false,false,false,false};


	//Bucle que pasa por todos los ficheros entre el begin y el end para cojer sus vertices
	for (cont=begin;cont<=end;cont++){
		printf("Loading %d\n",cont);

		//Abro el fichero correspondiente
		switch(tipo){
		case _LEGS:
			if (cont >=0 && cont <10) sprintf(nombreArchivo,"legs00%d.ase",cont);
			else if (cont >=10 && cont <100) sprintf(nombreArchivo,"legs0%d.ase",cont);
			else if (cont >=100 && cont <1000) sprintf(nombreArchivo,"legs%d.ase",cont);
			else return false;
			parte="\"LEGS\"";
			break;
		case _BODY:
			if (cont >=0 && cont <10) sprintf(nombreArchivo,"body00%d.ase",cont);
			else if (cont >=10 && cont <100) sprintf(nombreArchivo,"body0%d.ase",cont);
			else if (cont >=100 && cont <1000) sprintf(nombreArchivo,"body%d.ase",cont);
			else return false;
			parte="\"BODY\"";
			break;
		case _HEAD:
			if (cont >=0 && cont <10) sprintf(nombreArchivo,"head00%d.ase",cont);
			else if (cont >=10 && cont <100) sprintf(nombreArchivo,"head0%d.ase",cont);
			else if (cont >=100 && cont <1000) sprintf(nombreArchivo,"head%d.ase",cont);
			else return false;
			parte="\"HEAD\"";
			break;
		}

		origen=fopen(nombreArchivo,"r");
		if (!origen) return false;

		//Busco el punto de union inferior (Ese punto se considerara el origen del modelo)
		while (!feof(origen)){
			fscanf(origen,"%s",tempo);
			if (!strcmp(tempo,"*NODE_NAME")){
				fscanf(origen,"%s",tempo);
				if (!strcmp(tempo,"\"LOWER_POINT\"")){
					//Si esto se activa significara que ha encontrado este punto
					ok = true;

					do{
						fscanf(origen,"%s",tempo);
					}while (strcmp(tempo,"*TM_POS") && !feof(origen));

					//La "y" y la "z" se invierten y la x se niega para que la lea bien 
					//OpenGL
					fscanf (origen,"%f",&x_low);
					fscanf (origen,"%f",&z_low);
					fscanf (origen,"%f",&y_low);

					x_low=-x_low;

					x_low*=RATIO;
					y_low*=RATIO;
					z_low*=RATIO;

				}
			}
		}
		
		//Si no encuentra este punto sale del juego
		if (!ok) {
			printf("Error loading %s\n",nombreArchivo);
			return false;
		}


		rewind (origen);

		//Ahora busco los vertices del frame
		while (!feof(origen)){
			fscanf(origen,"%s",tempo);
			if (!strcmp(tempo,"*NODE_NAME")){
				fscanf(origen,"%s",tempo);
				if (!strcmp(tempo,parte)){
					done[0]=true;
					//Cojo el numero de vertices
					do{
						fscanf(origen,"%s",tempo);
					}while (strcmp(tempo,"*MESH_NUMVERTEX") && !feof(origen));
					fscanf(origen,"%d",&vertex);
					//Compruebo si es el primer frame de la animacion y si es dinamica o no
					if (cont==begin) {
						if (dinamico) fprintf(archivo,"\n*D\n");
						else fprintf(archivo,"\n*S\n");
					}
					else fprintf(archivo,"\n.\n");

					//Copio todos los vertices en el fichero
					for (register int i=0;i<vertex;i++){
						do{
							fscanf(origen,"%s",tempo);
						}while (strcmp(tempo,"*MESH_VERTEX") && !feof(origen));
						fscanf (origen,"%s");
						fscanf (origen,"%f",&x);
						fscanf (origen,"%f",&z);
						fscanf (origen,"%f",&y);

						//Le resto el LOWER_UNION para colocar el objeto en el centro de
						//coordenadas


						x*=RATIO;
						y*=RATIO;
						z*=RATIO;

						x = -x - x_low;
						y = y - y_low;
						z = z - z_low;
						fprintf(archivo,"%f %f %f\n",x,y,z);
					}
				}
				else if (!strcmp(tempo,"\"UPPER_POINT\"")){
					done[1]=true;
					do{
						fscanf(origen,"%s",tempo);
					}while (strcmp(tempo,"*TM_POS") && !feof(origen));
					fscanf (origen,"%f",&x);
					fscanf (origen,"%f",&z);
					fscanf (origen,"%f",&y);



					if (tipo==_LEGS){
						y+=bodyDesfas;
					}
					else if (tipo==_BODY){
						y+=headDesfas;
					}

					x*=RATIO;
					y*=RATIO;
					z*=RATIO;

					x = -x - x_low;
					y = y - y_low;
					z = z - z_low;


					fprintf(CAR,"%f %f %f\n",x,y,z);
				}
				else if (!strcmp(tempo,"\"WEAPON_POS\"")){
					done[2]=true;
					do{
						fscanf(origen,"%s",tempo);
					}while (strcmp(tempo,"*TM_POS") && !feof(origen));
					fscanf (origen,"%f",&weaponPos[numWeaponDest]);
					fscanf (origen,"%f",&weaponPos[numWeaponDest+2]);
					fscanf (origen,"%f",&weaponPos[numWeaponDest+1]);

					

					weaponPos[numWeaponDest]*=RATIO;
					weaponPos[numWeaponDest+1]*=RATIO;
					weaponPos[numWeaponDest+2]*=RATIO;

					weaponPos[numWeaponDest]=-weaponPos[numWeaponDest]- x_low;
					weaponPos[numWeaponDest+1]=weaponPos[numWeaponDest+1]- y_low;
					weaponPos[numWeaponDest+2]=weaponPos[numWeaponDest+2]- z_low;
					
				}
				else if (!strcmp(tempo,"\"WEAPON_DESTIN\"")){
					done[3]=true;
					do{
						fscanf(origen,"%s",tempo);
					}while (strcmp(tempo,"*TM_POS") && !feof(origen));
					fscanf (origen,"%f",&weaponDestiny[numWeaponDest]);
					fscanf (origen,"%f",&weaponDestiny[numWeaponDest+2]);
					fscanf (origen,"%f",&weaponDestiny[numWeaponDest+1]);

					weaponDestiny[numWeaponDest]*=RATIO;
					weaponDestiny[numWeaponDest+1]*=RATIO;
					weaponDestiny[numWeaponDest+2]*=RATIO;

					
					weaponDestiny[numWeaponDest]=-weaponDestiny[numWeaponDest]- x_low;
					weaponDestiny[numWeaponDest+1]=weaponDestiny[numWeaponDest+1]- y_low;
					weaponDestiny[numWeaponDest+2]=weaponDestiny[numWeaponDest+2]- z_low;
					
				}
			}
		}
		
		if (tipo==_BODY) numWeaponDest+=3;
		//Cierro el fichero
		fclose(origen);
	}



	if (tipo==_HEAD && done[0] && !done[1] && !done[2] && !done[3]) return true;
	else if (tipo==_BODY && done[0] && done[1] && done[2] && done[3]) return true;
	else if (tipo==_LEGS && done[0] && done[1] && !done[2] && !done[3]) return true;
	else return false;
	

}
